// Client side C program to demonstrate Socket
// programming

#define PORT 8180
#include <arpa/inet.h>
#include <netinet/in.h>
    int status, valread, client_fd,bytes_sent;
    struct sockaddr_in serv_addr;
    const char* end_trans = "END TRANSMISSION^\0";
    const char* end_conn = "END CONNECTION^\0";

    char buffer[512] = { 0 };

int connectToHost()
{    


    if ((client_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        printf("\n Socket creation error \n");
        return -1;
    }

    serv_addr.sin_family = AF_INET;
    serv_addr.sin_port = htons(PORT);

    // Convert IPv4 and IPv6 addresses from text to binary
    // form
    if (inet_pton(AF_INET, "127.0.0.1", &serv_addr.sin_addr)
        <= 0) {
        printf(
            "\nInvalid address/ Address not supported \n");
        return -1;
    }

    if ((status
         = connect(client_fd, (struct sockaddr*)&serv_addr,
                   sizeof(serv_addr)))
        < 0) {
        printf("\nConnection Failed \n");
        return -1;
    }
    return 0;
}


int sendDataRow(char * data)
{

    bytes_sent = send(client_fd, data, strlen(data), 0);
    
    valread = read(client_fd, buffer,
                       512 - 1); // subtract 1 for the null
    return bytes_sent;
        
}


int endConnection()
{
    send(client_fd,end_conn,strlen(end_conn),0);
    close(client_fd);
    return 0;
}
 